#include "chdecl.h"
void CH_chcode_chdictionary(current, sched, cop)
#define ARGUMENTS 6
#include "chhead.h"
select: switch (SELECTOR) {
    case 0: goto c0;
    case 1: goto cb2;
    case 2: goto c3;
    case 3: goto c14;
    case 4: goto cb17;
    case 6: goto cb19;
    case 7: goto c20;
    case 8: goto cb25;
    case 9: goto c26;
    case 5: goto c77;
    case 10: goto c77;
    case 11: goto c78;
    case 12: goto cb80;
    case 13: goto c81;
    case 14: goto c83;
    case 15: goto c85;
    case 16: goto c92;
    case 17: goto c98;  }
c0:
/* block , 0 */
  if((ch_returncode = che_block(QUAL(0),sched)) != Normal)
     goto ch_raise_exception;
/* block , 1 */
  if((ch_returncode = che_block(QUAL(1),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 1;
cb2:
/* receive 3 0 */
  if ((ch_returncode = che_receive(DEF(3),DEF(0),sched)) != Normal)
     goto ch_raise_exception;
  return;
c3:
/* discard 0 */
  (*(REF(0).tsdr)->finalize)(REF(0).value,F_DISCARD,sched);
  REF(0).tsdr = & dr_bottom;
/* new_inport 4 */
  if ((ch_val.inport = make_inport()) == nil) goto ch_depletion;
  (*(REF(4).tsdr)->finalize)(REF(4).value,F_DISCARD,sched);
  REF(4).value = ch_val; REF(4).tsdr = & dr_inport;
/* connect 3.0 4 */
  if (REF(4).value.inport->refcount == MAXCOUNTER) goto ch_depletion;
  (*(REF(3)DOT(0).tsdr)->finalize)(REF(3)DOT(0).value,F_DISCARD,sched);
  REF(4).value.inport->refcount++;
  REF(3)DOT(0).value.outport = REF(4).value.inport;
  REF(3)DOT(0).tsdr = & dr_outport;
/* new_inport 5 */
  if ((ch_val.inport = make_inport()) == nil) goto ch_depletion;
  (*(REF(5).tsdr)->finalize)(REF(5).value,F_DISCARD,sched);
  REF(5).value = ch_val; REF(5).tsdr = & dr_inport;
/* connect 3.1 5 */
  if (REF(5).value.inport->refcount == MAXCOUNTER) goto ch_depletion;
  (*(REF(3)DOT(1).tsdr)->finalize)(REF(3)DOT(1).value,F_DISCARD,sched);
  REF(5).value.inport->refcount++;
  REF(3)DOT(1).value.outport = REF(5).value.inport;
  REF(3)DOT(1).tsdr = & dr_outport;
/* return 3 */
  if (ch_caller = do_return(REF(3).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(3).value);
  REF(3).tsdr = & dr_bottom;
/* prog_lit 6 , 2 */
  if ((ch_returncode = che_prog_lit(DEF(6),QUAL(2),sched)) != Normal) 
     goto ch_raise_exception;
/* procedure 7 6 , 3 */
  if ((ch_returncode = che_procedure(DEF(7),DEF(6),QUAL(3),sched)) != Normal)
     goto ch_raise_exception;
/* discard 6 */
  (*(REF(6).tsdr)->finalize)(REF(6).value,F_DISCARD,sched);
  REF(6).tsdr = & dr_bottom;
/* move 8 7 */
  (*(REF(8).tsdr)->finalize)(REF(8).value,F_DISCARD,sched);
  REF(8) = REF(7);
  REF(7).tsdr = & dr_bottom;
/* new_table 9 , 4 */
  if ((ch_returncode = che_new_table(DEF(9),QUAL(4),sched)) != Normal) 
     goto ch_raise_exception;
c14:
/* noop */
  
/* block , 5 */
  if((ch_returncode = che_block(QUAL(5),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 4;
cb17:
/* select 5 * 4 * , 6 */
  if ((ch_returncode = che_select((
          arguments[0] = DEF(5),
          arguments[1] = NO_OBJECT,
          arguments[2] = DEF(4),
          arguments[3] = NO_OBJECT,
          arguments[3+1] = nil,& arguments[0]),QUAL(6),sched)) != Normal)
     goto ch_raise_exception;
  if (current->ip == 4) return; else COMPUTE_TARGET;
c19:
  current->ip = 6;
cb19:
/* receive 10 5 */
  if ((ch_returncode = che_receive(DEF(10),DEF(5),sched)) != Normal)
     goto ch_raise_exception;
  return;
c20:
/* ilit 11 , 0 */
  REF(11).value.integer = 0;
  REF(11).tsdr = & dr_integer;
/* find 12 9 10.0 , 0 */
  if (findfunc(DEF(12),DEF(9),(
          arguments[0] = DEF(10)DOT(0),& arguments[0]),sched,0) == FAILURE)
             goto ch_notfound;
/* copy 10.3 12.1 */
  REF(10)DOT(3) = REF(12)DOT(1);
/* branch , 78 */
   goto c78;
c25:
  current->ip = 8;
cb25:
/* receive 10 4 */
  if ((ch_returncode = che_receive(DEF(10),DEF(4),sched)) != Normal)
     goto ch_raise_exception;
  return;
c26:
/* size 13 10.0 */
  REF(13).value.integer = REF(10)DOT(0).value.table->size;
  REF(13).tsdr = & dr_integer;
/* notequal . 13 =(0) , 33 */
  if ( REF(13).value.integer != 0 ) goto c33;
/* ilit 10.3 , -1 */
  REF(10)DOT(3).value.integer = -1;
  REF(10)DOT(3).tsdr = & dr_integer;
/* branch , 78 */
   goto c78;
c33:
/* ilit 11 , 1 */
  REF(11).value.integer = 1;
  REF(11).tsdr = & dr_integer;
/* find 14 9 10.0 , 0 */
  if (findfunc(DEF(14),DEF(9),(
          arguments[0] = DEF(10)DOT(0),& arguments[0]),sched,0) == FAILURE)
             goto ch_notfound;
/* privatize 10.2 */
  if (REF(10)DOT(2).value.table->refcount != 1)
    if ((ch_returncode = doCopyOnWrite(DEF(10)DOT(2))) != Normal)
       goto ch_raise_exception;
/* lookup_at 15 10.2 14.1 */
  if((ch_i = REF(14)DOT(1).value.integer) < 0 || ch_i >= (ch_t = 
    REF(10)DOT(2).value.table)->size) goto ch_notfound;
  (*(REF(15).tsdr)->finalize)(REF(15).value,F_DISCARD,sched);
  (*(ch_t->tbls[ORDER_TBL].des->lookup_at))
    (ch_t, ORDER_TBL, & REF(15).value,ch_i);
  REF(15).tsdr = qdatarepmap[ch_t->tsdr->number];
/* remove_at 16 10.2 14.1 */
  if ((ch_returncode = remove_at_func(DEF(16),DEF(10)DOT(2),
    REF(14)DOT(1).value.integer)) != Normal) goto ch_raise_exception;
/* iadd 16.3 16.3 11 */
  if (!chf_iadd(DEF(16)DOT(3),REF(16)DOT(3).value.integer,
    REF(11).value.integer)) goto ch_depletion;
/* equal . 16.1 10.1 , 74 */
  if ( REF(16)DOT(1).value.ord_enum == REF(10)DOT(1).value.ord_enum ) goto c74;
/* ord_case 17 16.4 */
  REF(17).value.ord_enum = REF(16)DOT(4).value.variant->info.variant_case;
  REF(17).tsdr = & dr_ord_enumeration;
/* equal . 17 =(6) , 74 */
  if ( REF(17).value.ord_enum == 6 ) goto c74;
/* notequal . 16.1 =(15) , 52 */
  if ( REF(16)DOT(1).value.ord_enum != 15 ) goto c52;
/* copy 16.1 10.1 */
  REF(16)DOT(1) = REF(10)DOT(1);
/* branch , 74 */
   goto c74;
c52:
/* noop */
  
/* equal . 10.1 =(15) , 74 */
  if ( REF(10)DOT(1).value.ord_enum == 15 ) goto c74;
/* equal 18 10.1 =(5) */
  REF(18).value.boolean = (REF(10)DOT(1).value.ord_enum == 5);
  REF(18).tsdr = & dr_boolean;
/* equal 19 16.1 =(14) */
  REF(19).value.boolean = (REF(16)DOT(1).value.ord_enum == 14);
  REF(19).tsdr = & dr_boolean;
/* and 20 18 19 */
  REF(20).value.boolean = REF(18).value.boolean&REF(19).value.boolean;
  REF(20).tsdr = & dr_boolean;
/* branch_false 20 , 64 */
  if ( !REF(20).value.boolean ) goto c64;
/* ordenum_lit 16.1 , 5 */
  REF(16)DOT(1).value.ord_enum = 5;
  REF(16)DOT(1).tsdr = & dr_ord_enumeration;
/* branch , 74 */
   goto c74;
c64:
/* noop */
  
/* notequal 21 16.1 =(5) */
  REF(21).value.boolean = (REF(16)DOT(1).value.ord_enum != 5);
  REF(21).tsdr = & dr_boolean;
/* notequal 22 10.1 =(14) */
  REF(22).value.boolean = (REF(10)DOT(1).value.ord_enum != 14);
  REF(22).tsdr = & dr_boolean;
/* or 23 21 22 */
  REF(23).value.boolean = REF(21).value.boolean|REF(22).value.boolean;
  REF(23).tsdr = & dr_boolean;
/* branch_false 23 , 74 */
  if ( !REF(23).value.boolean ) goto c74;
/* unite 16.4 24 , 6 */
  if ((ch_returncode = che_unite(DEF(16)DOT(4),DEF(24),sched,6)) != Normal)
     goto ch_raise_exception;
/* ordenum_lit 16.1 , 15 */
  REF(16)DOT(1).value.ord_enum = 15;
  REF(16)DOT(1).tsdr = & dr_ord_enumeration;
c74:
/* copy 10.3 14.1 */
  REF(10)DOT(3) = REF(14)DOT(1);
/* insert_at 10.2 16 14.1 */
  ch_i = REF(14)DOT(1).value.integer;
  if (ch_i < 0 || REF(10)DOT(2).value.table->size < ch_i) goto ch_range_error;
  if ((ch_returncode = insertfunc(DEF(10)DOT(2),DEF(16),TRUE, ch_i
    )) != Normal) goto ch_raise_exception;
/* branch , 78 */
   goto c78;
c18:
c77:
/* exit , 7 */
  ch_e = handler_type__exit; ch_val = QUAL(7); goto ch_exception;
c78:
/* endblock */
  che_endblock(sched);
/* branch , 81 */
   goto c81;
c80:
  current->ip = 12;
cb80:
/* call 8 10 11 9 , 8 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(8),
          arguments[1] = DEF(10),
          arguments[2] = DEF(11),
          arguments[3] = DEF(9),
          arguments[3+1] = nil,& arguments[0]),QUAL(8),sched)) != Normal)
     goto ch_raise_exception;
  return;
c81:
/* return 10 */
  if (ch_caller = do_return(REF(10).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(10).value);
  REF(10).tsdr = & dr_bottom;
/* branch , 14 */
   goto c14;
c83:
/* endblock */
  che_endblock(sched);
/* branch , 92 */
   goto c92;
c85:
/* discard 0 */
  (*(REF(0).tsdr)->finalize)(REF(0).value,F_DISCARD,sched);
  REF(0).tsdr = & dr_bottom;
/* discard 4 */
  (*(REF(4).tsdr)->finalize)(REF(4).value,F_DISCARD,sched);
  REF(4).tsdr = & dr_bottom;
/* discard 5 */
  (*(REF(5).tsdr)->finalize)(REF(5).value,F_DISCARD,sched);
  REF(5).tsdr = & dr_bottom;
/* discard 8 */
  (*(REF(8).tsdr)->finalize)(REF(8).value,F_DISCARD,sched);
  REF(8).tsdr = & dr_bottom;
/* discard 10 */
  (*(REF(10).tsdr)->finalize)(REF(10).value,F_DISCARD,sched);
  REF(10).tsdr = & dr_bottom;
/* discard 9 */
  (*(REF(9).tsdr)->finalize)(REF(9).value,F_DISCARD,sched);
  REF(9).tsdr = & dr_bottom;
c92:
/* discard 4 */
  (*(REF(4).tsdr)->finalize)(REF(4).value,F_DISCARD,sched);
  REF(4).tsdr = & dr_bottom;
/* discard 5 */
  (*(REF(5).tsdr)->finalize)(REF(5).value,F_DISCARD,sched);
  REF(5).tsdr = & dr_bottom;
/* discard 8 */
  (*(REF(8).tsdr)->finalize)(REF(8).value,F_DISCARD,sched);
  REF(8).tsdr = & dr_bottom;
/* discard 9 */
  (*(REF(9).tsdr)->finalize)(REF(9).value,F_DISCARD,sched);
  REF(9).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
c98:
/* endprocess */
  che_endprocess(sched); return;
#include "chtail.h"
